//------------------------------------------------------------------------------
// shape_Area.cpp -   
//     
//------------------------------------------------------------------------------

#include "shape_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .
  double Area(rectangle &r);
  double Area(triangle &t);

//------------------------------------------------------------------------------

  //  ,    
  // .      
  //      .
  double Area_of_rectangle(shape &s)
  {
    return Area(*((rectangle*)s.s));
  }

//------------------------------------------------------------------------------

  //  ,    
  // .      
  //      .
  double Area_of_triangle(shape &s)
  {
    return Area(*((triangle*)s.s));
  }

//------------------------------------------------------------------------------

  //    .
  //   .  
  //   .
  double (*Area_of_shape[])(shape &s) = 
    {&Area_of_rectangle, &Area_of_triangle};


  //     
  //  ,      .
  //  .
  double Area(shape &s)
  {
    return Area_of_shape[s.k](s);
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
