//------------------------------------------------------------------------------
// shape_Out.cpp -     
//    
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_atd.h"

//------------------------------------------------------------------------------

using namespace std;

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .
  void Out(rectangle &r);
  void Out(triangle &t);

//------------------------------------------------------------------------------

  //  ,    
  // .      
  //      .
  void Out_rectangle(shape &s)
  {
    Out(*((rectangle*)s.s));
  }

//------------------------------------------------------------------------------

  //  ,    
  // .      
  //      .
  void Out_triangle(shape &s)
  {
    Out(*((triangle*)s.s));
  }

//------------------------------------------------------------------------------

  //    .
  //   .  
  //   .
  void (*Out_shape[])(shape &s) = 
    {&Out_rectangle, &Out_triangle};


  //     
  //  ,      .
  //  .
  void Out(shape &s)
  {
    Out_shape[s.k](s);
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
